package osclient

import (
	"code.fbi.h-da.de/danet/gnmi-target/examples/example01/osclient/additions"
	"github.com/openconfig/ygot/ygot"
)

// Osclient describes
type Osclient interface {
	additions.System
	additions.Interfaces
	additions.NetworkInstances
	UpdateConfig(config *ygot.ValidatedGoStruct) error
}

type client struct {
	additions.System
	additions.Interfaces
	additions.NetworkInstances
}

func NewOsClient() Osclient {
	newSys, err := additions.NewSystem()
	if err != nil {
		panic(err)
	}

	return &client{
		System:           newSys,
		Interfaces:       additions.NewInterfaces(),
		NetworkInstances: additions.NewNetworkInstances(),
	}
}

func (oc *client) UpdateConfig(config *ygot.ValidatedGoStruct) error {
	return nil
}
